// Copyright 2004 Adam Megacz, see the COPYING file for licensing [LGPL]
package org.ibex.io;

import java.net.*;
import java.io.*;
import org.ibex.util.*;

/** a stream backed by a socket */
public class Connection extends Stream {
    private final Socket s;
    public final String vhost;
    public Connection(Socket s, String vhost) { super(s); this.vhost = vhost; this.s = s; }
    public void close()                       { try{s.close();}catch(Exception e){throw new StreamException(e);} super.close(); }
    public int getLocalPort()                 { return s.getLocalPort(); }
    public InetAddress getLocalAddress()      { return ((InetSocketAddress)s.getLocalSocketAddress()).getAddress(); }
    public int getRemotePort()                { return s.getPort(); }
    public InetAddress getRemoteAddress()     { return ((InetSocketAddress)s.getRemoteSocketAddress()).getAddress(); }
    public String getRemoteHostname()         { return getRemoteAddress().getHostName(); }
    public String getVirtualHost()            { return vhost; }
    public void setTimeout(int ms)            { try { s.setSoTimeout(ms); } catch (Exception e){throw new StreamException(e); }}
    public void setTcpNoDelay(boolean delay)  { try { s.setTcpNoDelay(delay);}catch(Exception e){throw new StreamException(e); }}
}
